﻿unit UfrmMaitre;

// |===========================================================================|
// | UNITE UfrmMaitre                                                          |
// | développé par F.BASSO 2006                                                |
// | Unité principale de l'application Execas                                  |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Générale GNU publiée par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribué car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spécifique.                                                   |
// | Reportez-vous à la Licence Publique Générale GNU pour plus de détails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.2.0 Utilisation Edit unicode pour le mot de passe                   |
// |   1.0.1.0 Ajout de la gestion des programmes via XML                      |
// |   1.0.0.1 correction bug lancement appli comme regedit                    |
// |   1.0.0.0 Création de l'unité                                             |
// |===========================================================================|

interface

uses
  Windows, SysUtils, Variants, Classes, Forms,
  Dialogs, StdCtrls, inifiles, Controls ,uxml, ComCtrls,ucompounicode;

type

  TfrmMaitre = class(TForm)
    Login: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    cbxExecute: TComboBox;
    cmdLancer: TButton;
    cmdModifier: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdModifierClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdLancerClick(Sender: TObject);
  private
// ****************************************************************************
// * Déclarations privées                                                     *
// ****************************************************************************
    tabFichier : ttabfichier ;
    procedure runas(sUser, sDomain, sPassword, sExecutable,sCommandeline : widestring);

  public
// ****************************************************************************
// * Déclarations publiques                                                   *
// ****************************************************************************
    mdlXml : TdtXml;
    unpassword : TTntEdit ;
    procedure TrieTableau (var tab : ttabfichier );
  end;

var
  frmMaitre: TfrmMaitre;

implementation

uses UFrmGestion;

{$R *.dfm}

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Déclarations externes                                                     #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

function CreateProcessWithLogonW(
         lpUsername          : PWideChar;
         lpDomain            : PWideChar;
         lpPassword          : PWideChar;
         dwLogonFlags        : DWORD;
         lpApplicationName   : PWideChar;
         lpCommandLine       : PWideChar;
         dwCreationFlags     : DWORD;
         lpEnvironment       : Pointer;
         lpCurrentDirectory  : PWideChar;
         Const lpStartupInfo : TStartupInfo;
         Var lpProcessInfo   : TProcessInformation):Bool;stdcall;external 'advapi32.dll';

const
  LOGON_WITH_PROFILE = 1;
  LOGON_NETCREDENTIALS_ONLY = 2;

  Function StrLectureVersion : String;

//  ___________________________________________________________________________
// | function  StrLectureVersion                                               |
// | _________________________________________________________________________ |
// || Permet d'avoir le numero de version de l'appli                          ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Version de l'appli                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Réservation en mémoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\FileVersion'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;


// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Privée                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TfrmMaitre.TrieTableau ( var tab : ttabfichier );
//  ___________________________________________________________________________
// | procedure TfrmMaitre.TrieTableau                                          |
// | _________________________________________________________________________ |
// || Permet de trier un tableau de type TtabFichier                          ||
// ||_________________________________________________________________________||
// || Entrées |  var tab : ttabfichier                                        ||
// ||         |    Tableau à trier                                            ||
// ||_________|_______________________________________________________________||
// || Sorties |  var tab : ttabfichier                                        ||
// ||         |    Tableau trié                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i , k: integer;
  nbuser : integer;
  temp : tfichier ;
  bootrie : boolean;
begin
  nbuser := length(tab);
  k := 0;
  for i := 0 to nbuser - 1 do tab[i].nom := LowerCase(tab[i].nom);
  bootrie := false;
  while not bootrie do
  begin
    bootrie := true;
    for i := k to nbuser - 2 do
      if tab[i].nom > tab[i+1].nom then
      begin
        bootrie := false;
        temp := tab[i+1];
        tab[i+1]:= tab[i];
        tab[i] := temp;
      end;
  end;
end;


procedure TfrmMaitre.runas(sUser, sDomain, sPassword, sExecutable,sCommandeline : WideString );
//  ___________________________________________________________________________
// | procedure TfrmMaitre.runas                                                |
// | _________________________________________________________________________ |
// || Permet d'executer une commande sous le compte d'un autre utilisateur    ||
// ||_________________________________________________________________________||
// || Entrées | sUser : string                                                ||
// ||         |   login de l'utilisateur à utiliser pour executer la commande ||
// ||         | sDomain : string                                              ||
// ||         |   Domaine de l'utilisateur                                    ||
// ||         | sPassword : string                                            ||
// ||         |   Mot de passe de l'utilisateur                               ||
// ||         | sExecutable : string                                          ||
// ||         |   Chemin complet de l'executable à lancer                     ||
// ||         | sCommandeline : string                                        ||
// ||         |   commande à passer à l'executable                            ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  wCommandeLine: WideString;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin

  wCommandeLine := '"' +sExecutable +'"' ;

// ****************************************************************************
// * Evite l'ajoute de "" apres ligne de commande créant problème avec appli  *
// * comme regedit                                                            *
// ****************************************************************************

  if sCommandeline <> '' then
    wCommandeLine := wCommandeLine + ' "'+sCommandeline +'"';

// ****************************************************************************
// * Initialisation de la structure Tstartupinfo pour affichage de            *
// * l'application en fenêtre normal                                          *
// ****************************************************************************

  FillChar(StartupInfo, SizeOf(StartupInfo), 0);
  StartupInfo.cb := SizeOf(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_SHOWNORMAL;

// ****************************************************************************
// * Execution de la commande si pas réussi affiche l'erreur                  *
// ****************************************************************************

  if not CreateProcessWithLogonW(pwidechar(suser){pwidechar(wUsername)},
                                 pwidechar(sdomain){ pwidechar(wDomain )},
                                 pwidechar(spassword){ pwidechar(wPassword)},
                                 1,
                                 nil,
                                 pwidechar(wCommandeLine),
                                 CREATE_DEFAULT_ERROR_MODE,
                                 nil,
                                 nil,
                                 StartupInfo,
                                 ProcessInfo) then
    RaiseLastOSError;
end;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie événementiel                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TfrmMaitre.cmdLancerClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdLancerClick                                       |
// | _________________________________________________________________________ |
// || Permet de lancer la commande choisi dans la liste                       ||
// ||_________________________________________________________________________||
// || Entrées | Sender: TObject                                               ||
// ||         |   Objet émetteur de l'événement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if (cbxExecute.ItemIndex = -1)or (login.Text ='') then exit;
  runas(login.text,
        '',
        unpassword.Text,
        tabfichier[cbxExecute.itemindex].exe ,
        tabfichier[cbxExecute.itemindex].com );
end;

procedure TfrmMaitre.FormCreate(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.FormCreate                                           |
// | _________________________________________________________________________ |
// || Permet à la création de la fiche de charger la liste des commandes      ||
// ||_________________________________________________________________________||
// || Entrées | Sender: TObject                                               ||
// ||         |   Objet émetteur de l'événement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i : integer;
  intnbFichier     : integer;
begin

// ****************************************************************************
// * Recuperation de la version du programme et des données du fichier XML    *
// ****************************************************************************

  caption := caption +' V'+ StrLectureVersion ;
  cbxExecute.Items.Clear ;
  cbxExecute.Text := 'Choisissez un programme dans la liste';

  mdlXml := TdtXml.Create(self);
  intnbFichier := mdlXml.ChargerFichier(tabFichier );
  if intnbFichier < 0 then exit;

// ****************************************************************************
// * Trie du tableau et affichage dans la liste                               *
// ****************************************************************************

  TrieTableau(tabFichier) ;
  for i :=0 to intnbFichier -1 do
    cbxExecute.Items.Add(tabfichier[i].nom);

// ****************************************************************************
// * Création du Edit password unicode                                        *
// ****************************************************************************

  unpassword := TTntEdit.Create(self);
  with unpassword do
  begin
    Parent := self ;
    ParentWindow := Self.Handle ;
    AutoSelect := true;
    AutoSize := true;
    BevelEdges :=[beLeft,beTop,beRight,beBottom];
    BevelInner := bvRaised ;
    BevelKind := bknone;
    BevelOuter := bvLowered ;
    BevelWidth := 1;
    BorderStyle := bsSingle ;
    Ctl3D := true;
    Enabled := true;
    height := 21;
    left := 88;
    PasswordChar := '*';
    TabOrder := 1;
    tabstop := true;
    top := 40;
    width := 273;
  end;
end;

procedure TfrmMaitre.cmdModifierClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdModifierClick                                     |
// | _________________________________________________________________________ |
// || Permet l'ouverture de la fiche d'edition des programmes                 ||
// ||_________________________________________________________________________||
// || Entrées | Sender: TObject                                               ||
// ||         |   Objet émetteur de l'événement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
var
  intnbfichier : integer;
  i : integer;
begin

// ****************************************************************************
// * Affichage de la fenêtre de gestion                                       *
// ****************************************************************************

  frmgestion.ShowModal ;

// ****************************************************************************
// * Réinitialisation de la listebox et Chargement de la liste des programmes *
// ****************************************************************************

  cbxExecute.Items.Clear ;
  cbxExecute.Text := 'Choisissez un programme dans la liste';
  intnbFichier := mdlXml.ChargerFichier(tabFichier );
  if intnbFichier < 0 then exit;

// ****************************************************************************
// * Trie du tableau et affichage dans la listebox                            *
// ****************************************************************************

  TrieTableau(tabFichier) ;
  for i :=0 to intnbFichier -1 do
    cbxExecute.Items.Add(tabfichier[i].nom);
end;

procedure TfrmMaitre.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  unpassword.Text :='';
  unpassword.Free ;
end;

end.
